/* ========================================================================== */
/*!
 * 
 */
/* ========================================================================== */
using System;
using System.Reflection;
using System.IO;
using System.Diagnostics;
using System.Windows.Forms;

namespace RecTestSched
{
    partial class ScheduleForm
    {
        //!
        static private ScheduleForm mySchForm = null;
        //!
        private string myAppPath;

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public ScheduleForm GetInstance()
        {
            if (mySchForm == null)
            {
                mySchForm = new ScheduleForm();
            }
            return mySchForm;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public void DelInstance()
        {
            if (mySchForm != null)
            {
                mySchForm.Visible = false;
                mySchForm.Close();
                mySchForm.Dispose();
                mySchForm = null;
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void Initialize()
        {
            //myAppPath = Path.GetDirectoryName(Process.GetCurrentProcess().MainModule.FileName);
            string execDir = Path.GetDirectoryName(Process.GetCurrentProcess().MainModule.FileName);
            myAppPath = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData)
                      + "\\magicAnime\\RecTestSched_"
                      + General.ToMd5(execDir)
                      + "\\";

            AssemblyName asmName = Assembly.GetExecutingAssembly().GetName();
            this.Text = "RecTest Scheduler for mAgicAnime.NET"
                      + "  Ver." + asmName.Version.Major + "." + asmName.Version.Minor + asmName.Version.Build;

            ConvertVersion(execDir, myAppPath);

            dataGridViewDriver.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            dataGridViewChannel.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            dataGridViewSchedule.SelectionMode = DataGridViewSelectionMode.FullRowSelect;

            DefaultOption();

            DefaultComboBox();
            DefaultDriverBox();
            DefaultScheduleBox();

            if (LoadingConfig())
            {
                //this.WindowState = FormWindowState.Minimized;
                this.Visible = false;
                this.Show();
                this.Visible = false;
                this.Close();
            }
            else
            {
                ShowDriverWindow();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void Release()
        {
            ExportConfig();
            ExportSchedule();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void ConvertVersion(string _execDir, string _appDir )
        {
            try
            {
                if (Directory.Exists(_appDir) == false)
                {
                    Directory.CreateDirectory(_appDir);
                    string refer = ";The following exe file refers to this directory. "
                                 + Environment.NewLine
                                 + _execDir
                                 + Environment.NewLine
                                 ;
                    File.WriteAllText(Path.Combine(_appDir, @"refer.txt"), refer);
                }
                General.Move(_execDir, _appDir, @"RecTestConfig.xml");
                General.Move(_execDir, _appDir, @"RecTestSchedule.xml");
                General.Move(_execDir, _appDir, @"RecTestConfig.xml.bak");
                General.Move(_execDir, _appDir, @"RecTestSchedule.xml.bak");
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }

        }

    }
}