/* ========================================================================== */
/*!
 * 
 */
/* ========================================================================== */
using System;
using System.Reflection;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.Collections;

namespace RecTestSched
{
    partial class ScheduleForm
    {
        //!
        [DllImport("User32.dll", EntryPoint = "SendMessage")]
        public static extern int SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, ref COPYDATASTRUCT lParam);

        //!
        [DllImport("User32.dll", EntryPoint = "SendMessage")]
        public static extern int SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, IntPtr lParam);

        //!
        private const int WM_COPYDATA = 0x4A;
        //!
        private const int WM_APP = 0x8000;
        //!
        private const int WM_RECSCH = WM_APP + 0x10;
        //!
        private const int WM_RECSCH_CH_LIST = WM_APP + 0x10;
        //!
        private const int iEPG_DATA = 0x612A08FE;
        //!
        private const int CHANNEL_DATA = 0x423D88D8;
        //!
        public struct COPYDATASTRUCT
        {
            public IntPtr dwData;
            public Int32  cbData;
            public IntPtr lpData;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        protected override void WndProc(ref Message msg)
        {
            switch (msg.Msg)
            {
                case WM_COPYDATA:
                    switch((int)msg.WParam)
                    {
                        case iEPG_DATA: RecviEPG(msg); break;
                        case CHANNEL_DATA: break;
                        default: base.WndProc(ref msg); break;
                    }
                    break;

                case WM_RECSCH_CH_LIST:
                    {
                        SendChannelList(msg);
                    }
                    break;

                default:
                    base.WndProc(ref msg);
                    break;
            }           
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        void RecviEPG(Message _msg)
        {
            try
            {
                COPYDATASTRUCT copyData = new COPYDATASTRUCT();
                copyData = (COPYDATASTRUCT)_msg.GetLParam(copyData.GetType());
                if (copyData.cbData > 0)
                {
                    DefaultScheduleBox();
                    string txtString = Marshal.PtrToStringAnsi(copyData.lpData);
                    string[] iEPG = txtString.Split('\n');
                    this.Invoke((MethodInvoker)delegate()
                                {
                                    iEPGScheduleData( iEPG[0]
                                                    , iEPG[1]
                                                    , Convert.ToDateTime(iEPG[2])
                                                    , iEPG[3]
                                                    );
                                }
                                );
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        void SendChannelList(Message _msg)
        {
            try
            {
                string strList = "";
                List<string> chList = new List<string>();
                OnUpdateChannel(chList);
                foreach (string name in chList)
                {
                    //if (name[0] == '{') { break; }
                    if (strList != "") { strList += '\n'; }
                    strList += name;
                }
                byte[] byteArray = System.Text.Encoding.Default.GetBytes(strList);
                COPYDATASTRUCT dataSend = new COPYDATASTRUCT();
                dataSend.dwData = IntPtr.Zero;
                dataSend.lpData = Marshal.StringToHGlobalAnsi(strList);
                dataSend.cbData = byteArray.Length + 1;
                SendMessage(_msg.LParam, WM_COPYDATA, (IntPtr)CHANNEL_DATA, ref dataSend);
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }


    }
}